# LIST ENTITIES

## Syntax <a href="#synopsis" id="synopsis"></a>

```sql
[ LIST | SHOW ] ENTITIES
[IN fully_qualified_entity_name]
[IN STORE store_name];
```

## Description

This command creates a new entity supported by a [store](https://docs.deltastream.io/overview/core-concepts/store). You can then use the entity to host [relations](https://docs.deltastream.io/overview/core-concepts/databases#_relation) created through [DDL](https://docs.deltastream.io/reference/sql-syntax/ddl) or [query](https://docs.deltastream.io/reference/sql-syntax/query).

This command lists entities that are present under the entity name specified by `fully_qualified_entity_name`. If `fully_qualified_entity_name` is not provided, the system returns the entities under the root namespace.

Entities are listed only if the current role has USAGE privileges on the store.

> Note: For stores with a large number of entities, this command limit the list to 1000 entities.

### Arguments <a href="#parameters" id="parameters"></a>

#### IN fully\_qualified\_entity\_name

Optionally, this lists entities under the provided entity name. Otherwise, the system returns the root entities.

#### IN STORE store\_name

Optionally, this lists the entities in the specified store. By default, the system uses the current session's store.

## Examples

#### List Kafka topics in the current store

The following lists the entities in the current store:

```sh
demodb.public/kafka_store# LIST ENTITIES;
+--------------+----------+
|  Name        |  Is Leaf |
+==============+==========+
| pageviews    | true     |
+--------------+----------+
| pageviews_pb | true     |
+--------------+----------+
| users        | true     |
+--------------+----------+
```

#### List Snowflake databases

```sh
demodb.public/sfstore# LIST ENTITIES;
+-----------------+------------+
|  Name           |  Is Leaf   |
+=================+============+
| MY_SNOWFLAKE_DB | false      |
+-----------------+------------+
| SNOWFLAKE       | false      |
+-----------------+------------+
| SNOWFLAKE_SAMPL | false      |
| E_DATA          |            |
+-----------------+------------+
```

#### List Snowflake schemas in a database

```sh
demodb.public/sfstore# LIST ENTITIES IN "DELTA_STREAMING";
+---------------------+------------+
|  Name               |  Is Leaf   |
+=====================+============+
| MY_STREAMING_SCHEMA | false      |
+---------------------+------------+
| PUBLIC              | false      |
+---------------------+------------+  
```

#### List Snowflake tables in a schema

```sh
demodb.public/sfstore# LIST ENTITIES IN "DELTA_STREAMING"."PUBLIC";
+---------------------+------------+
|  Name               |  Is Leaf   |
+=====================+============+
| STREAM_DATA_TBL     | true       |
+---------------------+------------+
| sf_pv_table         | true       |
+---------------------+------------+      
```

#### List Databricks catalogs

```sh
demodb.public/databricks_store# LIST ENTITIES;
+------------+------------+
|  Name      |  Is Leaf   |
+============+============+
| catalog1   | false      |
+------------+------------+
| main       | false      |
+------------+------------+
| system     | false      |
+------------+------------+
```

#### List Databricks schemas in a catalog

```sh
demodb.public/databricks_store# LIST ENTITIES in catalog1;
+--------------------+------------+
|  Name              |  Is Leaf   |
+====================+============+
| default            | false      |
+--------------------+------------+
| information_schema | false      |
+--------------------+------------+
```

#### List Databricks tables in a schema

```sh
demodb.public/databricks_store# LIST ENTITIES IN catalog1.schema1;
+--------------------+------------+
|  Name              |  Is Leaf   |
+====================+============+
| pageviews          | true       |
| pv_agg             | true       |
+--------------------+------------+ 
```

#### List schemas in a Postgresql store

```sh
demodb.public/databricks_store# LIST ENTITIES;
+------------+------------+
|  Name      |  Is Leaf   |
+============+============+
| public     | false      |
+------------+------------+
```

#### List Postgresql tables in a schema

```sh
demodb.public/psqlstore# LIST ENTITIES in public;
+--------------------+------------+
|  Name              |  Is Leaf   |
+====================+============+
| pageviews          | true       |
+--------------------+------------+ 
```

#### List Snowflake databases in a specific store

```sh
demodb.public/kafka_store# LIST ENTITIES IN STORE sfstore;
+-----------------+------------+
|  Name           |  Is Leaf   |
+=================+============+
| MY_SNOWFLAKE_DB | false      |
+-----------------+------------+
| SNOWFLAKE       | false      |
+-----------------+------------+
| SNOWFLAKE_SAMPL | false      |
| E_DATA          |            |
+-----------------+------------+
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.deltastream.io/reference/sql-syntax/command/list-entities.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
